// Demo 3.6.14
// Arrays #2 class code
// Another way to build and initialize an array
// Arrays as arguments
// Printing the values in an array
// Counting the different values in an array.
// Summing the values in an array.
// Filtering the values in an array.

final int MAX = 3;


boolean [ ] boolList1, boolList2 ;
int [ ] intList1, intList2;
                         
void setup( )
{
  size( 500, 500 );
  textSize( 24 );
  fill( 255 );
  
  boolList1 = new boolean[ MAX ];
  boolList2 = new boolean[ MAX * 2 ];

  initializeBooleanArray( boolList1 );
  initializeBooleanArray( boolList2 );  
  
  intList1 = new int [ MAX ];
  intList2 = new int [ MAX + 1 ];
  
  initializeIntArray( intList1, 5, 51 );
  initializeIntArray( intList2, 1, 11 );
}

void draw( )
{
  background( 0 );
  demoBooleanArrays( );
  //demoIntArrays( );
  
 
}

void initializeBooleanArray( boolean [ ] anyBooleanArray )
{
  for( int i = 0; i < anyBooleanArray.length; i++)
  {
    if ( random( 2 ) >= 1 )
    {
       anyBooleanArray[ i ] = true;
    }
    else
    {
      anyBooleanArray[ i ] = false; 
    }
  }    
}


void initializeIntArray( int [ ] anyIntArray, int minVal, int maxVal )
{
  for( int i = 0; i < anyIntArray.length; i++)
  {
    anyIntArray[ i ] = int( random( minVal, maxVal) );
  }
}


void demoBooleanArrays( )
{
  printBooleanArray( boolList1, 50 );
  printBooleanArray( boolList2, 200 );  
  int trueCount = countTrueValues( boolList1 );
  text( "boolList1 has " + trueCount + " true and " + (boolList1.length-trueCount) + " false values.", 10, 390 );
  trueCount = countTrueValues( boolList2 );
  text( "boolList2 has " + trueCount + " true and " + (boolList2.length-trueCount) + " false values.", 10, 420 );   
}

void  printBooleanArray( boolean [ ] anyBooleanArray, int yLoc )
{
  for( int i = 0; i < anyBooleanArray.length; i++)
  {
    text( "" + anyBooleanArray[ i ], width/2, yLoc + i*30 );
  }
}

int countTrueValues( boolean [ ] anyBooleanArray )
{
  int counter = 0;
  for( int i = 0; i < anyBooleanArray.length; i++)
  {
    if ( anyBooleanArray[i] == true )  counter++;  
  }
  return counter;
}

void demoIntArrays( )
{
  printIntArray(intList1, 30 );
  printIntArray(intList2, 150 );
  int sum1 = sumValues( intList1 );
  text( "intList1 sum1 is  " + sum1, 10, 280 );
  int sum2 = sumValues( intList2 );
  text( "intList2 sum2 is  " + sum2, 10, 310 );
  float average1 = float(sum1)/intList1.length;
  float average2 = float(sum2)/intList2.length;  
  text( "intList1 average is  " + average1, 10, 340 );  
  text( "intList2 average is  " + average2, 10, 370 );   
  text( "Values in intList1 > the average:", 10, 400 );
  printValuesGreaterThanAverage( intList1, average1, 430 );
  text( "Values in intList2 > the average:", 10, 460 );
  printValuesGreaterThanAverage( intList2, average2, 490 );
}

void  printIntArray( int [ ] anyIntArray, int yLoc )
{
  for( int i = 0; i < anyIntArray.length; i++)
  {
    text( "" + anyIntArray[ i ], width/2, yLoc + i*30 );
  } 
}

int  sumValues( int [ ] anyIntArray )
{
  int sum = 0;
  for( int i = 0; i < anyIntArray.length; i++)
  {
    sum += anyIntArray[ i ];
  } 
  return sum;
}

void printValuesGreaterThanAverage( int [ ] anyIntArray, float average, int yLoc )
{
 int xLoc = 10;
 for( int i = 0; i < anyIntArray.length; i++)
  {
   if ( anyIntArray[ i ]  > average )
   {
       text( anyIntArray[ i ], xLoc, yLoc );
       xLoc += 50;
   }
  }   
}
                         
